        SUBROUTINE AEA (IA, IE, NC )
C$$$    SUBPROGRAM DOCUMENTATION  BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    AEA         ASCII TO EBCDIC, OR EBCDIC TO ASCII
C   PRGMMR: DESMARAIS        ORG: W342       DATE: 82-11-29
C
C ABSTRACT: CONVERT ASCII TO EBCDIC, OR EBCDIC TO ASCII BY CHARACTER.
C
C PROGRAM HISTORY LOG:
C   82-11-29  DESMARAIS
C   88-03-31  R.E.JONES  CHANGE LOGIC SO IT WORKS LIKE A
C                        IBM370 TRANSLATE INSTRUCTION.
C   88-08-22  R.E.JONES  CHANGES FOR MICROSOFT FORTRAN 4.10
C   88-09-04  R.E.JONES  CHANGE TABLES TO 128 CHARACTER SET
C   89-08-16  R.E.JONES  CHANGE TO IBM370 VS FORTRAN
C   90-06-11  R.E.JONES  CHANGE TO SUN FORTRAN 1.3
C   91-03-28  R.E.JONES  CHANGE TO SiliconGraphics FORTRAN
C   98-07-07  EBISUZAKI  LINUX PORT
C
C USAGE:    CALL AEA (IA, IE, NC)
C   INPUT ARGUMENT LIST:
C     IA       - CHARACTER*1 ARRAY OF ASCII DATA IF NC < 0
C     IE       - CHARACTER*1 ARRAY OF EBCDIC DATA IF NC > 0
C     NC       - INTEGER,  CONTAINS CHARACTER COUNT TO CONVERT....
C                IF NC .LT. 0,  CONVERT ASCII TO EBCDIC
C                IF NC .GT. 0,  CONVERT EBCDIC TO ASCII
C
C   OUTPUT ARGUMENT LIST:
C     IA       - CHARACTER*1 ARRAY OF ASCII DATA IF NC > 0
C     IE       - CHARACTER*1 ARRAY OF EBCDIC DATA IF NC < 0
C
C
C REMARKS: SOFTWARE VERSION OF IBM370 TRANSLATE INSTRUCTION, BY
C   CHANGING THE TWO TABLES WE COULD DO A  64, 96, 128  ASCII
C   CHARACTER SET, CHANGE LOWER CASE TO UPPER, ETC.
C
C ATTRIBUTES:
C   LANGUAGE: HP FORTRAN 77
C   MACHINE:  Hewlett-Packard 9000/705, 715, 735, 750, 755, 712
C
C$$$
C***   ASCII  CONTAINS ASCII CHARACTERS, AS PUNCHED ON IBM029
C
      CHARACTER * 1  IA(*)
      CHARACTER * 1  IE(*)
      CHARACTER * 1  ASCII(0:255)
      CHARACTER * 1  ASCII1(0:127)
      CHARACTER * 1  ASCII2(0:127)
      CHARACTER * 1  EBCDIC(0:255)
C
      EQUIVALENCE    (ASCII(0),ASCII1(0))
      EQUIVALENCE    (ASCII(128),ASCII2(0))
C
       DATA  ASCII1 /
     & '00'X,'01'X,'02'X,'03'X,'00'X,'09'X,'00'X,'7F'X,
     & '00'X,'00'X,'00'X,'0B'X,'0C'X,'0D'X,'0E'X,'0F'X,
     & '10'X,'11'X,'12'X,'00'X,'00'X,'00'X,'00'X,'00'X,
     & '18'X,'19'X,'00'X,'00'X,'00'X,'00'X,'00'X,'00'X,
     & '00'X,'00'X,'1C'X,'00'X,'0A'X,'00'X,'17'X,'00'X,
     & '00'X,'00'X,'00'X,'00'X,'00'X,'05'X,'06'X,'07'X,
     & '00'X,'00'X,'16'X,'00'X,'00'X,'1E'X,'00'X,'04'X,
     & '00'X,'00'X,'00'X,'00'X,'14'X,'15'X,'00'X,'1A'X,
     & '20'X,'00'X,'60'X,'00'X,'00'X,'00'X,'00'X,'00'X,
     & '00'X,'00'X,'60'X,'2E'X,'3C'X,'28'X,'2B'X,'00'X,
     & '26'X,'00'X,'00'X,'00'X,'00'X,'00'X,'00'X,'00'X,
     & '00'X,'00'X,'21'X,'24'X,'2A'X,'29'X,'3B'X,'5E'X,
     & '2D'X,'2F'X,'00'X,'00'X,'00'X,'00'X,'00'X,'00'X,
     & '00'X,'00'X,'7C'X,'2C'X,'25'X,'5F'X,'3E'X,'3F'X,
     & '00'X,'00'X,'00'X,'00'X,'00'X,'00'X,'00'X,'00'X,
     & '00'X,'60'X,'3A'X,'23'X,'40'X,'27'X,'3D'X,'22'X/
       DATA  ASCII2 /
     & '20'X,'61'X,'62'X,'63'X,'64'X,'65'X,'66'X,'67'X,
     & '68'X,'69'X,'20'X,'20'X,'20'X,'20'X,'20'X,'20'X,
     & '20'X,'6A'X,'6B'X,'6C'X,'6D'X,'6E'X,'6F'X,'70'X,
     & '71'X,'72'X,'20'X,'20'X,'20'X,'20'X,'20'X,'20'X,
     & '20'X,'7E'X,'73'X,'74'X,'75'X,'76'X,'77'X,'78'X,
     & '79'X,'7A'X,'20'X,'20'X,'20'X,'5B'X,'20'X,'20'X,
     & '00'X,'00'X,'00'X,'00'X,'00'X,'00'X,'00'X,'00'X,
     & '00'X,'00'X,'00'X,'00'X,'00'X,'5D'X,'00'X,'00'X,
     & '7B'X,'41'X,'42'X,'43'X,'44'X,'45'X,'46'X,'47'X,
     & '48'X,'49'X,'20'X,'20'X,'20'X,'20'X,'20'X,'20'X,
     & '7D'X,'4A'X,'4B'X,'4C'X,'4D'X,'4E'X,'4F'X,'50'X,
     & '51'X,'52'X,'20'X,'20'X,'20'X,'20'X,'20'X,'20'X,
     & '5C'X,'20'X,'53'X,'54'X,'55'X,'56'X,'57'X,'58'X,
     & '59'X,'5A'X,'20'X,'20'X,'20'X,'20'X,'20'X,'20'X,
     & '30'X,'31'X,'32'X,'33'X,'34'X,'35'X,'36'X,'37'X,
     & '38'X,'39'X,'20'X,'20'X,'20'X,'20'X,'20'X,'20'X/
C
C***  EBCDIC CONTAINS HEX. REPRESENTATION OF EBCDIC CHARACTERS
C
       DATA  EBCDIC /
     & '00'X,'01'X,'02'X,'03'X,'37'X,'2D'X,'2E'X,'2F'X,
     & '16'X,'05'X,'25'X,'0B'X,'0C'X,'0D'X,'0E'X,'0F'X,
     & '10'X,'11'X,'12'X,'00'X,'3C'X,'3D'X,'32'X,'26'X,
     & '18'X,'19'X,'3F'X,'27'X,'22'X,'00'X,'35'X,'00'X,
     & '40'X,'5A'X,'7F'X,'7B'X,'5B'X,'6C'X,'50'X,'7D'X,
     & '4D'X,'5D'X,'5C'X,'4E'X,'6B'X,'60'X,'4B'X,'61'X,
     & 'F0'X,'F1'X,'F2'X,'F3'X,'F4'X,'F5'X,'F6'X,'F7'X,
     & 'F8'X,'F9'X,'7A'X,'5E'X,'4C'X,'7E'X,'6E'X,'6F'X,
     & '7C'X,'C1'X,'C2'X,'C3'X,'C4'X,'C5'X,'C6'X,'C7'X,
     & 'C8'X,'C9'X,'D1'X,'D2'X,'D3'X,'D4'X,'D5'X,'D6'X,
     & 'D7'X,'D8'X,'D9'X,'E2'X,'E3'X,'E4'X,'E5'X,'E6'X,
     & 'E7'X,'E8'X,'E9'X,'AD'X,'E0'X,'BD'X,'5F'X,'6D'X,
     & '79'X,'81'X,'82'X,'83'X,'84'X,'85'X,'86'X,'87'X,
     & '88'X,'89'X,'91'X,'92'X,'93'X,'94'X,'95'X,'96'X,
     & '97'X,'98'X,'99'X,'A2'X,'A3'X,'A4'X,'A5'X,'A6'X,
     & 'A7'X,'A8'X,'A9'X,'C0'X,'6A'X,'D0'X,'A1'X,'07'X,
     & 128*'40'X/
C
      NUM = IABS(NC)
C
      IF (NC .EQ. 0)   RETURN
C
      IF (NC .GT. 0)   THEN
C
C***  CONVERT STRING ...  EBCDIC TO ASCII,   NUM CHARACTERS
C
        DO  10  J = 1, NUM
          IA(J) = ASCII(iichar(IE(J)))
 10     CONTINUE
C
      ELSE
C
C***  CONVERT STRING ...  ASCII TO EBCDIC,   NUM CHARACTERS
C
        DO  20  J = 1, NUM
          IE(J) = EBCDIC(iichar(IA(J)))
 20     CONTINUE
      END IF
C
      RETURN
      END
